<template>
    <div v-if="limit !== null">
        <input
            v-bind:value="limit.value" 
            v-on:input="(limit.value = $event.target.value) && map.paths.updateColors(map._mapboxMap)" 
            class="slider" 
            step="0.01" min="0" max="1000"
            type="range">
        <div>
            <a
                v-bind:style="{
                    backgroundColor: limit.color,
                    borderColor: blender.blend(limit.color, '#000000', 0.3)
                }"
                v-on:mouseover="genColorButtonStyle($event.target, limit.color, 0.1)"
                v-on:mouseleave="genColorButtonStyle($event.target, limit.color)"
                v-on:click="palette = ! palette"
                class="button is-small is-rounded palette-color is-marginless"
            />

            <input
                v-bind:value="limit.value" 
                v-on:input="(limit.value = $event.target.value) && map.paths.updateColors(map._mapboxMap)" 
                class="input is-small is-rounded number-input"
                min="0" max="1000"
                type="number">
        </div>
        <div v-if="palette" class="has-small-top-margin">
            <a
                v-bind:key="color.key" 
                v-for="color in PALETTE"
                v-bind:style="{
                    backgroundColor: color,
                    borderColor: blender.blend(color, '#000000', 0.3)
                }"
                v-on:mouseover="genColorButtonStyle($event.target, color, 0.1)"
                v-on:mouseleave="genColorButtonStyle($event.target, color)"
                v-on:click="(limit.color = color) && map.paths.updateColors(map._mapboxMap)"
                class="button is-small is-rounded palette-color"
            />
        </div>
    </div>
</template>

<script lang="ts">
    import { Component, Prop, Vue } from 'vue-property-decorator';
    import { State } from 'vuex-class';
    import Dropdown from './Dropdown.vue';
    import IconBase from './IconBase.vue';

    import { COLORS } from '@/ts/enums';
    import { Mapview } from '@/ts/mapview';
    import { Blender } from '@/ts/blender';

    @Component({
        components: {
            Dropdown,
            IconBase,
        },
    })
    export default class BarLimits extends Vue {
        @Prop()
        // private name!: LimitType;

        @State('map') private map!: Mapview;

        private readonly PALETTE = [
            COLORS.BLUE,
            COLORS.GREEN,
            COLORS.YELLOW,
            COLORS.ORANGE,
            COLORS.RED,
            COLORS.PURPLE,
            COLORS.GREY,
            COLORS.WHITE,
        ];
        private blender: Blender = new Blender();
        private limit: Limit | null = null;
        private palette: boolean = false;

        private mounted() {
            // (this.name === 'low') ? this.limit = this.map.paths.limitLow : this.limit = this.map.paths.limitHigh;
        }

        private genColorButtonStyle(element: any, color: string, percentage?: number) {
            if (percentage === undefined) {
                element.style.backgroundColor = color;
                element.style.borderColor = this.blender.blend(color, '#000000', 0.3);
            } else {
                element.style.backgroundColor = this.blender.blend(color, '#000000', percentage);
                element.style.borderColor = this.blender.blend(color, '#000000', percentage + 0.3);
            }
        }
    }
</script>

<style scoped>
    .palette-color {
        border-width: 2px;
        margin: 0.2rem;
    }

    .number-input {
        width: 80px;
    }

    .slider {
        -webkit-appearance: none;
        width: 120px;
        height: 4px;
        border-radius: 5px;
        background: #d4d4d4;
        outline: none;
        opacity: 1;
        margin: 0.5rem;
        -webkit-transition: .2s;
        transition: opacity .2s;
    }

    .slider::-webkit-slider-thumb {
        -webkit-appearance: none;
        appearance: none;
        width: 12px;
        height: 12px;
        border-radius: 50%;
        background-color: #4a4a4a;
        cursor: pointer;
    }
</style>
